//
// DoDs Speed Bonus Round
// -----------------------------
// Based form <eVa>Dog's Dog Bonus Round
// http://www.dodsplugins.com
//
// For DoD:Source
// This plugin beacon the losing Team and give speed to the Winners
// Just to have a funny moment at round end
// -----------------------------

#include <sourcemod>
#include <sdktools>

#define SPEC 1
#define ALLIES 2
#define AXIS 3

#define PLUGIN_VERSION "2.0"
#define BEACON_DELAY 1.5

new g_beamSprite
new g_haloSprite

new String:WpnMelee[4][] = { "", "", "weapon_amerknife", "weapon_spade" }

new Handle:g_BeaconTimer[MAXPLAYERS + 1];
new Handle:cvar_kicknodl = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "DoD Baronettes Bonus Round",
	author = "<eVa>Dog,vintage",
	description = "Beacon and skin the loosing Team, give speed to the Winners",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.com"
}

public OnPluginStart()
{
	CheckGame()

	HookEvent("dod_round_start", Hook_RoundStart, EventHookMode_Post)
	HookEvent("dod_round_win", Hook_RoundWin, EventHookMode_Post)
	cvar_kicknodl = CreateConVar("dod_baronettes_bonusround_kicknodl", "1", "Enabled/Disabled kicking players with DL-filter, 0 = off/1 = on", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	AutoExecConfig(true, "dod_baronettes_bonusround", "dod_baronettes_bonusround")
}

public OnMapStart()
{
	PrecacheModel("models/player/baronettes/superman.mdl")
	PrecacheSound("buttons/button17.wav",true)
	PrecacheSound("dod_sexy_bonusround/benny.mp3", true)
	g_beamSprite = PrecacheModel("materials/sprites/laser.vmt")
	g_haloSprite = PrecacheModel("materials/sprites/halo01.vmt")
	AddFileToDownloadsTable("sound/dod_speed_bonusround/benny.mp3")
	AddFileToDownloadsTable("models/player/baronettes/superman.dx80.vtx")
	AddFileToDownloadsTable("models/player/baronettes/superman.dx90.vtx")
	AddFileToDownloadsTable("models/player/baronettes/superman.phy")
	AddFileToDownloadsTable("models/player/baronettes/superman.sw.vtx")
	AddFileToDownloadsTable("models/player/baronettes/superman.vvd")
	AddFileToDownloadsTable("models/player/baronettes/superman_suit.vmt")
	AddFileToDownloadsTable("models/player/baronettes/superman_suit.vtf")
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit_n.vtf")
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vtf")
	AddFileToDownloadsTable("materials/models/player/baronettes/superman_suit.vmt")
	AddFileToDownloadsTable("models/player/baronettes/superman.mdl")
}

public OnClientAuthorized(client, const String:auth[])
{
	if(GetConVarInt(cvar_kicknodl) == 1)
	{
		QueryClientConVar(client, "cl_downloadfilter", ConVarQueryFinished:dlfilter);
	}
}

public dlfilter(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName1[], const String:cvarValue1[])
{
	if(IsClientConnected(client))
	{
		if(strcmp(cvarValue1, "none", true) == 0)
		{
			KickClient(client, "Please enable SkinDownload and reconnect!");
		}
	}
}

public Hook_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new x = 1; x <= MaxClients; x++)
	{
		if(!IsClientConnected(x) || !IsClientInGame(x))
		{
			continue
		}
		ResetTimer(x)
	}
}

public Hook_RoundWin(Handle:event, const String:name[], bool:dontBroadcast)
{
	EmitSoundToAll("dod_sexy_bonusround/benny.mp3")
	new winnerTeam = GetEventInt(event, "team")

	for (new x = 1; x <= MaxClients; x++)
	{
		if(!IsClientInGame(x) || !IsPlayerAlive(x))
		{
			continue
		}
		
		if(GetClientTeam(x) == winnerTeam)
		{
			StripWeapons(x)
			SetEntPropFloat(x, Prop_Data, "m_flLaggedMovementValue", 1.5)
			GivePlayerItem(x,WpnMelee[winnerTeam])

			continue
		}
		else
		StripWeapons(x)		
		SetEntityModel(x,"models/player/baronettes/superman.mdl")
		PrintCenterText(x, "DANGER! Run! Run! Run!")

		g_BeaconTimer[x] = CreateTimer(BEACON_DELAY, BeaconTimer, x, TIMER_REPEAT)
	}
}

public Action:BeaconTimer(Handle:timer, any:client)
{
	if(!client || !IsClientInGame(client) || !IsClientConnected(client) || !IsPlayerAlive(client))
	{
		ResetTimer(client)

		return Plugin_Handled
	}

	BeamRing(client)
	new Float:vecPos[3]
	GetClientAbsOrigin(client, vecPos)
	EmitSoundToAll("buttons/button17.wav", client, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 1.0, SNDPITCH_NORMAL, -1, vecPos, NULL_VECTOR, true, 0.0)

	return Plugin_Handled
}


CheckGame()
{
	new String:strGame[10]
	GetGameFolderName(strGame, sizeof(strGame))

	if(StrEqual(strGame, "dod"))
	{
		PrintToServer("[dod_baronettes_bonusround] Version %s dod_sexy_bonusround loaded.", PLUGIN_VERSION)
	}
	else
	{
		SetFailState("[dod_baronettes_bonusround] This plugin is made for DOD:S! Disabled.")
	}
}

BeamRing(client)
{
	new color[] = {248, 96, 244, 255}

	new Float:vec[3]
	GetClientAbsOrigin(client, vec)

	vec[2] += 5;

	TE_Start("BeamRingPoint")
	TE_WriteVector("m_vecCenter", vec)
	TE_WriteFloat("m_flStartRadius", 20.0)
	TE_WriteFloat("m_flEndRadius", 440.0)
	TE_WriteNum("m_nModelIndex", g_beamSprite)
	TE_WriteNum("m_nHaloIndex", g_haloSprite)
	TE_WriteNum("m_nStartFrame", 0)
	TE_WriteNum("m_nFrameRate", 0)
	TE_WriteFloat("m_fLife", 1.0)
	TE_WriteFloat("m_fWidth", 6.0)
	TE_WriteFloat("m_fEndWidth", 6.0)
	TE_WriteFloat("m_fAmplitude", 0.0)
	TE_WriteNum("r", color[0])
	TE_WriteNum("g", color[1])
	TE_WriteNum("b", color[2])
	TE_WriteNum("a", color[3])
	TE_WriteNum("m_nSpeed", 50)
	TE_WriteNum("m_nFlags", 0)
	TE_WriteNum("m_nFadeLength", 0)
	TE_SendToAll()
}

ResetTimer(client)
{
	if(g_BeaconTimer[client] != INVALID_HANDLE)
	{
		KillTimer(g_BeaconTimer[client]);
		g_BeaconTimer[client] = INVALID_HANDLE
	}
}

public Action:StripWeapons(x)
{
	for(new i = 0; i < 4; i++)
	{
		new weapon = GetPlayerWeaponSlot(x, i)
		if(weapon != -1)
		{
			RemovePlayerItem(x, weapon)
			RemoveEdict(weapon)
		}
	}
}